'Compilable Example:
'Credits: Arto Schroderus for his Sudoku generator code (www.freevbcode.com/ShowCode.asp?ID=7986)

#Compiler PBWin 10
#Compile Exe "gbsudoku.exe"
#Dim All
#Debug Error On
#Debug Display On

%Unicode = 1
#Include "cwindow.inc"
#Include "files\gbOnlineUpdate.inc"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "images\sudoku.ico"
#Resource Icon xreset "images\reset.ico"
#Resource Icon xsettings "images\settings.ico"
#Resource Icon xhelp "images\help.ico"
#Resource Icon x0 "images\0.ico"
#Resource Icon x1 "images\1.ico"
#Resource Icon x2 "images\2.ico"
#Resource Icon x3 "images\3.ico"
#Resource Icon x4 "images\4.ico"
#Resource Icon x5 "images\5.ico"
#Resource Icon x6 "images\6.ico"
#Resource Icon x7 "images\7.ico"
#Resource Icon x8 "images\8.ico"
#Resource Icon x9 "images\9.ico"
#Resource Icon xup "images\up.ico"
#Resource Icon xdown "images\down.ico"
#Resource Icon xleft "images\left.ico"
#Resource Icon xright "images\right.ico"
#Resource Icon xright "images\right.ico"
#Resource Icon xclear "images\clear.ico"
#Resource Icon xxprint "images\print.ico"
#Resource Icon xreveal "images\reveal.ico"
#Resource Icon xcandidates "images\candidates.ico"
#Resource Icon xcopy "images\copy.ico"
#Resource Icon xdraw "images\draw.ico"
#Resource Icon xundo "images\undo.ico"
#Resource Icon xredo "images\redo.ico"
#Resource Icon xcancelb "images\cancelb.ico"
#Resource Icon xempty "images\empty.ico"
#Resource Icon xaspect "images\aspect.ico"
#Resource Icon aaa "images\sudoku.ico"

#Resource Wave,   x1, "files\1.wav"
#Resource Wave,   x2, "files\2.wav"
#Resource Wave,   x3, "files\3.wav"
#Resource Wave,   x4, "files\4.wav"
#Resource Wave,   x5, "files\5.wav"
#Resource Wave,   x6, "files\6.wav"
#Resource Wave,   x7, "files\7.wav"
#Resource Wave,   x8, "files\8.wav"
#Resource Wave,   x9, "files\9.wav"

$Ver = "2.01"
$SessionFile = "games\session.sud"

Type UndoType
   x As Long
   y As Long
   n As Long
End Type

Type CustomColors
   c(15) As Long
End Type

Enum Equates Singular
   IDC_Graphic = 500
   IDC_Toolbar
   IDC_ToolbarB

   IDT_New
   IDT_Reset
   IDT_Clear
   IDT_Print
   IDT_Settings

   IDT_Up
   IDT_Down
   IDT_Left
   IDT_Right

   IDT_Suggest
   IDT_Notes
   IDT_Empty
   IDT_Reveal
   IDT_Copy
   IDT_Aspect

   IDT_Undo
   IDT_Redo

   IDT_0
   IDT_1
   IDT_2
   IDT_3
   IDT_4
   IDT_5
   IDT_6
   IDT_7
   IDT_8
   IDT_9

   IDT_Help

   IDM_0
   IDM_1
   IDM_2
   IDM_3
   IDM_4
   IDM_5
   IDM_6
   IDM_7
   IDM_8
   IDM_9
   IDM_Up
   IDM_Down
   IDM_Left
   IDM_Right

   IDM_Note1
   IDM_Note2
   IDM_Note3
   IDM_Note4
   IDM_Note5
   IDM_Note6
   IDM_Note7
   IDM_Note8
   IDM_Note9

   IDM_Test
   IDM_OnlineUpdate
   IDM_Clear
   IDM_Reset
   IDM_Reveal
   IDM_AllowSpeech
   IDM_ShowCaption
   IDM_MaintainAR
   IDM_Info
   IDM_HighlightError
   IDM_AskConfirmation
   IDM_CompactToolbar
   IDM_AutoSave
   IDM_AllowDragNumber
   IDM_LandScape
   IDM_Debug
   IDM_Information
   IDM_LocalHelp
   IDM_Print
   IDM_Copy
   IDM_Suggest
   IDM_Notes
   IDM_Empty
   IDM_AllowAlerts

   IDM_OrigCellColor
   IDM_UserCellColor
   IDM_EmptyCellColor

   IDM_OrigBigNumberColor
   IDM_UserBigNumberColor
   IDM_SuggestColor
   IDM_NoteColor
   IDM_NoteGrayColor
   IDM_SelectionColor
   IDM_DefaultColors
   IDM_SetAspectRatio

   IDM_ClearNotesCell
   IDM_ClearNotesAll
   IDM_Sep

   ID_Timer

End Enum

%Orig  = 0
%User  = 1

Type BoxType
   x0 As Long         'upper
   y0 As Long         'left
   x1 As Long         'right
   y1 As Long         'bottom
End Type

Type CellType
   number As Long          'num 0-9
   box As Long              '1-9
   x0 As Long               'upper
   y0 As Long               'left
   x1 As Long               'right
   y1 As Long               'bottom
   type As Long             'Orig 'User 'Empty
   bgColor As Long          'cell background color
   bignumbercolor As Long   'color of big numbers
   suggeststatus(9) As Long
   suggestcolor(9) As Long
   notestatus(9) As Long
   notecolor(9) As Long
   noterect(9) As Rect
   sloc(9) As BoxType       'location of 4 corners of box containing each candidate
End Type

Global hDlg,hGraphic,hFont,hFont1000,hFontS,hFontSB,hFontT,hToolbar,hContext As Dword
Global hColors,hImageList,hToolbarB,hSettings,hTxtWin,ghHook,hHelp As Dword
Global SX, SY, StartQty, ShowNotes,ShowSuggest,ShowEmpty, MaintainAR,Edge, AutoSave As Long
Global AllowSpeech, TBM, FontSize, FontAttr, Debug, HighlightError, CompactToolbar, AskConfirmation, Landscape As Long

Global OrigCellColor, UserCellColor, EmptyCellColor, SelectionColor, UndoPos, MaxUndoPos As Long
Global OrigBigNumberColor, UserBigNumberColor, SuggestColor, NoteColor, NoteGrayColor,ShowCaption As Long
Global PreDragResult, DragResult, AllowDragNumber, AllowAlerts As Long

Global arrSudoku() As Integer, CustomColorList As CustomColors, UndoData() As UndoType
Global EmptyD, D() As CellType, AspectRatio As Single, sBox() As BoxType
Global qStart, qStop, qFreq As Quad, FontName As WStringZ * %Max_Path

Function PBMain() As Long
   Dialog New Pixels, 0, "gbSudoku " + $ver,,,400,500, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateToolbarStuff
   Control Add Graphic, hDlg, %IDC_Graphic,"", 0,100,400,400  ', IIf(AllowDraw, 0, %SS_Notify)
   Control Handle hDlg, %IDC_Graphic To hGraphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Set Overlap
   Graphic Set Mix %R2_CopyPen
   Dialog Show Modal hDlg Call DlgProc
   If RestartUpdate Then RestartUpdatedEXE
End Function

CallBack Function DlgProc() As Long
   Local w,h,x,y,iResult,OldSX,OldSY As Long, temp$, pt As Point
   Local nmtb As TBNotify Ptr, PTT As TooltipText Ptr, rc As Rect

   Select Case Cb.Msg
      Case %WM_InitDialog
         hUpdateParent = hDlg
         GetDebug
         QueryPerformanceFrequency qFreq
         CreateSubFolders
         AspectRatio = 1.0
         ReDim D(9,9)
         ReDim arrSudoku(80) 'Clear the Sudoku Array
         ResetUndoData
         ReDim sBox(9)
         Randomize Timer
         Settings_INI "get"
         CreateToolbarsOnly
         CreateEmptyD
         BuildAcceleratorTable
         CreateContextMenu
         Font New "Tahoma",1000,1 To hFont1000 'used only in calculations
         Font New "Tahoma",12,1 To hFont       'bignumber
         Font New "Tahoma",8,0 To hFontT       'toolbar
         Font New "Tahoma",8,0 To hFontS       'small number
         Font New "Tahoma",8,1 To hFontSB       'small number
         Control Set Font hDlg, %IDC_Toolbar, hFontT
         Graphic Set Font hFont
         If IsFile($SessionFile) Then LoadSession Else CreateSudoku : BuildDArray(40)
         DrawPuzzle
         SetMenusAndToolbar
         QueryPerformanceCounter qStart
         SetTimer(hDlg, %ID_Timer, 500, 0)

      Case %WM_Destroy
         KillTimer hDlg, %ID_Timer
         If IsFile($SessionFile) Then Kill $SessionFile
         If AutoSave Then SaveSession
         Settings_INI "save"

      Case %WM_Timer
         QueryPerformanceCounter qStop
         If ShowCaption Then
            x = (qStop-qStart)/qFreq
            Dialog Set Text hDlg, "gbSudoku " + $ver + Space$(10) + "ET: " + Format$(x\60,"##0") + ":" + Format$(x Mod 60,"00") + "      Selection: " + Str$(SX) + "," + Str$(SY)
         Else
            Dialog Set Text hDlg, "gbSudoku " + $ver
         End If

      Case %WM_Size : ResizeWindow

      Case %WM_ContextMenu
         pt.x = Lo(Integer,Cb.LParam) : pt.y = Hi(Integer, Cb.LParam)
         TrackPopupMenu hContext, %TPM_LeftAlign, pt.x, pt.y, 0, Cb.Hndl, ByVal 0

      Case %WM_LButtonDown
         pt.x = Lo(Integer,Cb.LParam)
         pt.y = Hi(Integer,Cb.LParam)
         If ChildWindowFromPoint(hDlg, pt) = hGraphic Then
            OldSX = SX : OldSY = SY
            GetCurrentXY(pt)
            DrawPuzzle
            If D(SX,SY).type = %Orig      Then Exit If
            If AllowDragNumber = 0        Then Exit If
            If OldSX <> SX Or OldSY <> SY Then Exit If
            PreDragResult = D(SX,SY).number
            SetCapture hDlg    'start capturing, so can detect LButtonUp when it occurs
         End If

      Case %WM_MouseMove
         If GetCapture() = hDlg Then   'app has capture    'why?
            x = Lo(Integer,Cb.LParam)
            y = Hi(Integer,Cb.LParam) - TBM
            Graphic Box (D(SX,SY).noterect(1).nLeft,D(SX,SY).noterect(1).nTop) - _
                        (D(SX,SY).noterect(9).nRight,D(SX,SY).noterect(9).nBottom),,D(SX,SY).bgcolor,D(SX,SY).bgcolor 'clear small numbers
            If y > D(SX,SY).y1 Then
               DragResult = PreDragResult
            Else
               DragResult = 10 * (D(SX,SY).y1 - y) \ (D(SX,SY).y1 - D(SX,SY).y0)
               DragResult = Max(DragResult,1)
               DragResult = Min(DragResult,9)
            End If
            D(SX,SY).number = DragResult
            DrawSmallNumbers
            DrawBigNumbers
            Graphic ReDraw
         End If

      Case %WM_LButtonUp
         If GetCapture() = hDlg Then
            x = Lo(Integer,Cb.LParam)
            y = Hi(Integer,Cb.LParam) - TBM
            D(SX,SY).number = PreDragResult

            If DragResult = 0 Then
               D(SX,SY).bgColor = EmptyCellColor
               GetCellCandidates
               DrawPuzzle
            ElseIf y > D(SX,SY).y1 Then
               If RuleCheck(PreDragResult,1) Then SetUndoData(SX,SY) : GetCellCandidates : DrawPuzzle : GameCheck
            Else
               If RuleCheck(DragResult,1) Then SetUndoData(SX,SY) : GetCellCandidates : DrawPuzzle : GameCheck
            End If
            ReleaseCapture
         End If

      Case %WM_LButtonDblClk
         pt.x = Lo(Integer,Cb.LParam)
         pt.y = Hi(Integer,Cb.LParam) - TBM
         For x = 1 To 9
            If PtInRect(D(SX,SY).noterect(x), pt) Then
               iResult = 1
               D(SX,SY).notestatus(x) = D(SX,SY).notestatus(x) Xor 1
               D(SX,SY).notecolor(x)  = IIf(D(SX,SY).notestatus(x), NoteColor, NoteGrayColor)
            End If
         Next x
         If iResult Then DrawPuzzle


      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_New
               If AskConfirmation Then
                  ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                  Select Case MessageBox(0, "Create new game? Current game will be lost!", "Open Game", %MB_YesNo + %MB_IconQuestion)
                     Case %IdYes   : ResetUndoData : CreateSudoku : BuildDArray(40) : DrawPuzzle : QueryPerformanceCounter qStart
                     Case %IdNo    : 'no action
                  End Select
                  UnhookWindowsHookEx ghHook
               Else
                  ResetUndoData : CreateSudoku : BuildDArray(40) : DrawPuzzle : QueryPerformanceCounter qStart
               End If

            Case %IDM_Reset, %IDT_Reset
               'remove user-entered values
               If AskConfirmation Then
                  ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                  Select Case MessageBox(0, "Erase all user inputs?", "Reset Game", %MB_YesNo + %MB_IconQuestion)
                     Case %IdYes   : ResetUndoData : RemoveUserEntries : GetCellCandidates : DrawPuzzle
                     Case %IdNo    : 'no action
                  End Select
                  UnhookWindowsHookEx ghHook
               Else
                  ResetUndoData : RemoveUserEntries : GetCellCandidates : DrawPuzzle
               End If

            Case %IDT_Reveal, %IDM_Reveal
               If D(SX,SY).type = %User Then
                  iResult = arrSudoku(9*(SY-1) + SX - 1)
                  If AllowAlerts Then RemoveConflictingCandidates iResult
                  D(SX,SY).number  = iResult
                  D(SX,SY).bgcolor = UserCellColor
                  SetUndoData(SX,SY)
                  GetCellCandidates : DrawPuzzle : GameCheck
               Else
                  If AllowSpeech Then
                     ReadText "This is a puzzle cell, which is already revealed!"
                  Else
                     Beep
                  End If
               End If

            Case %IDT_Redo : Redo
            Case %IDT_Undo : Undo

            Case %IDM_Clear, %IDT_Clear
               'remove fixed and user-entered values
               If AskConfirmation Then
                  ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                  Select Case MessageBox(0, "Erase all values?", "Clear Game", %MB_YesNo + %MB_IconQuestion)
                     Case %IdYes   : BuildDArray(-1) : DrawPuzzle : QueryPerformanceCounter qStart
                     Case %IdNo    : 'no action
                  End Select
                  UnhookWindowsHookEx ghHook
               Else
                  BuildDArray(-1) : DrawPuzzle : QueryPerformanceCounter qStart
               End If

            Case %IDT_Copy, %IDM_Copy
               Clipboard Reset
               Clipboard Set Bitmap hGraphic

            Case %IDT_Print, %IDM_Print
               PrintGame
               Graphic Attach hDlg, %IDC_Graphic

            Case %IDT_Empty, %IDM_Empty
               ShowNotes = ShowEmpty : ShowSuggest = ShowEmpty
               ShowEmpty = ShowEmpty Xor 1
               DrawPuzzle
               SetMenusAndToolbar

            Case %IDT_Notes, %IDM_Notes
               ShowSuggest = ShowNotes : ShowEmpty = ShowNotes
               ShowNotes = ShowNotes Xor 1
               DrawPuzzle
               SetMenusAndToolbar

            Case %IDT_Suggest, %IDM_Suggest
               ShowNotes = ShowSuggest : ShowEmpty = ShowSuggest
               ShowSuggest = ShowSuggest Xor 1
               DrawPuzzle
               SetMenusAndToolbar

            Case %IDT_Help
               temp$ = "http://www.garybeene.com/sw/gbsudoku.htm"
               w = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_MaintainAR
               MaintainAR = MaintainAr Xor 1
               SetMenusAndToolbar

            Case %IDM_0, %IDT_0
               If D(SX,SY).type = %Orig Then
                  If AllowSpeech Then
                     ReadText "This is a puzzle cell. It cannot be cleared!"
                  Else
                     Beep
                  End If
               Else
                  SetUndoData SX,SY
                  D(SX,SY).number  = 0
                  D(SX,SY).bgColor = EmptyCellColor
                  GetCellCandidates
                  DrawPuzzle
               End If

            Case %IDM_1, %IDT_1 : If RuleCheck(1,1) Then GetCellCandidates : DrawPuzzle : GameCheck
            Case %IDM_2, %IDT_2 : If RuleCheck(2,1) Then GetCellCandidates : DrawPuzzle : GameCheck
            Case %IDM_3, %IDT_3 : If RuleCheck(3,1) Then GetCellCandidates : DrawPuzzle : GameCheck
            Case %IDM_4, %IDT_4 : If RuleCheck(4,1) Then GetCellCandidates : DrawPuzzle : GameCheck
            Case %IDM_5, %IDT_5 : If RuleCheck(5,1) Then GetCellCandidates : DrawPuzzle : GameCheck
            Case %IDM_6, %IDT_6 : If RuleCheck(6,1) Then GetCellCandidates : DrawPuzzle : GameCheck
            Case %IDM_7, %IDT_7 : If RuleCheck(7,1) Then GetCellCandidates : DrawPuzzle : GameCheck
            Case %IDM_8, %IDT_8 : If RuleCheck(8,1) Then GetCellCandidates : DrawPuzzle : GameCheck
            Case %IDM_9, %IDT_9 : If RuleCheck(9,1) Then GetCellCandidates : DrawPuzzle : GameCheck

            Case %IDM_Note1 : ToggleNote(1) : DrawPuzzle
            Case %IDM_Note2 : ToggleNote(2) : DrawPuzzle
            Case %IDM_Note3 : ToggleNote(3) : DrawPuzzle
            Case %IDM_Note4 : ToggleNote(4) : DrawPuzzle
            Case %IDM_Note5 : ToggleNote(5) : DrawPuzzle
            Case %IDM_Note6 : ToggleNote(6) : DrawPuzzle
            Case %IDM_Note7 : ToggleNote(7) : DrawPuzzle
            Case %IDM_Note8 : ToggleNote(8) : DrawPuzzle
            Case %IDM_Note9 : ToggleNote(9) : DrawPuzzle

            Case %IDM_Up, %IDT_Up       : Decr SY : SY = Max(1,SY) : DrawPuzzle
            Case %IDM_Down, %IDT_Down   : Incr SY : SY = Min(9,SY) : DrawPuzzle
            Case %IDM_Left, %IDT_Left   : Decr SX : SX = Max(1,SX) : DrawPuzzle
            Case %IDM_Right, %IDT_Right : Incr SX : SX = Min(9,SX) : DrawPuzzle

            Case %IDM_SetAspectRatio, %IDT_Aspect : SetAspectRatio(1) : ResizeWindow

            Case %IDM_HighlightError
               HighlightError = HighlightError Xor 1
               SetMenusAndToolbar

            Case %IDM_AutoSave
               AutoSave = AutoSave Xor 1
               SetMenusAndToolbar

            Case %IDM_CompactToolbar
               CompactToolbar = CompactToolbar Xor 1
               Control Kill hDlg, %IDC_Toolbar
               Control Kill hDlg, %IDC_ToolbarB
               CreateToolbarsOnly
               SetMenusAndToolbar

            Case %IDM_AllowAlerts
               AllowAlerts = AllowAlerts Xor 1
               SetMenusAndToolbar

            Case %IDM_AskConfirmation
               AskConfirmation = AskConfirmation Xor 1
               SetMenusAndToolbar

            Case %IDM_Landscape
               Landscape = Landscape Xor 1
               SetMenusAndToolbar

            Case %IDM_AllowSpeech
               AllowSpeech = AllowSpeech Xor 1
               SetMenusAndToolbar

            Case %IDM_AllowDragNumber
               AllowDragNumber = AllowDragNumber Xor 1
               SetMenusAndToolbar

            Case %IDM_ShowCaption, %IDT_Settings
               ShowCaption = ShowCaption Xor 1
               SetMenusAndToolbar

            Case %IDM_Test

            Case %IDM_Information
               DisplayDData

            Case %IDM_Debug
               Debug = Debug Xor 1
               If Debug Then
                  Txt.Window "Debug", 300,300,40,40 To hTxtWin
               Else
                  Txt.End
               End If

            Case %IDM_OrigCellColor   : OrigCellColor  = SelectColor(OrigCellColor)  : RebuildColors : DrawPuzzle
            Case %IDM_UserCellColor   : UsercellColor  = SelectColor(UserCellColor)  : RebuildColors : DrawPuzzle
            Case %IDM_EmptyCellColor  : EmptyCellColor = SelectColor(EmptyCellColor) : RebuildColors : DrawPuzzle

            Case %IDM_OrigBigNumberColor : OrigBigNumberColor = SelectColor(OrigBigNumberColor) : RebuildColors : DrawPuzzle
            Case %IDM_UserBigNumberColor : UserBigNumberColor = SelectColor(UserBigNumberColor) : RebuildColors : DrawPuzzle
            Case %IDM_SuggestColor       : SuggestColor       = SelectColor(SuggestColor)       : RebuildColors : DrawPuzzle
            Case %IDM_NoteColor          : NoteColor          = SelectColor(NoteColor)          : RebuildColors : DrawPuzzle
            Case %IDM_NoteGrayColor      : NoteGrayColor      = SelectColor(NoteGrayColor)      : RebuildColors : DrawPuzzle

            Case %IDM_SelectionColor     : SelectionColor = SelectColor(SelectionColor) : RebuildColors : DrawPuzzle

            Case %IDM_DefaultColors
               OrigCellColor      = %rgb_Wheat
               UserCellColor      = %rgb_SkyBlue
               EmptyCellColor     = %White
               OrigBigNumberColor = %Black
               UserBigNumberColor = %Black
               SuggestColor       = %Red
               NoteColor          = %Blue
               NoteGrayColor      = %rgb_LightGray
               SelectionColor     = %Red
               RebuildColors : DrawPuzzle

            Case %IDM_LocalHelp    : DisplayLocalHelp
            Case %IDM_OnlineUpdate : CheckForEXEUpdates($ver)

            Case %IDM_ClearNotesCell : ClearNotes(0) : DrawPuzzle   '0=selected cell
            Case %IDM_ClearNotesAll  : ClearNotes(1) : DrawPuzzle   '1=all
         End Select

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                 Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_Help
                       Call TrackPopupMenu (hHelp, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_New To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         PTT = Cb.LParam
                         @PTT.@lpszText = SetToolTips(Cb.NmId)
                  End Select
           End Select
   End Select
End Function

Sub BuildDArray(LevelOfDifficulty As Long)
   If Debug Then Txt.Print FuncName$
   ClearDArray
   BuildCellCoordinates  'figure out coordinates of upperleft and lowerright of each cell x0y0x1y1
   SetNewGameCellProperites(LevelOfDifficulty)
   GetCellCandidates
End Sub

Sub DrawPuzzle
   If Debug Then Txt.Print FuncName$
   Graphic Clear EmptyCellColor
   DrawCellColors
   DrawOutlines
   DrawBigNumbers
   DrawSmallNumbers
   DrawSelection
   Graphic ReDraw
End Sub

Sub DrawCellColors
   If Debug Then Txt.Print FuncName$
   Local x,y As Long
   Graphic Width 1
   For x = 1 To 9
      For y = 1 To 9
         Graphic Box (D(x,y).x0,D(x,y).y0)-(D(x,y).x1,D(x,y).y1),,D(x,y).bgColor, D(x,y).bgColor
      Next y
   Next x
   Graphic Width 4
End Sub

Sub DrawOutlines
   If Debug Then Txt.Print FuncName$
   Graphic Width 1
   'Small lines
   Graphic Box (D(1,2).x0,D(1,2).y0)-(D(9,2).x1,D(9,2).y1),,%Black
   Graphic Box (D(1,5).x0,D(1,5).y0)-(D(9,5).x1,D(9,5).y1),,%Black
   Graphic Box (D(1,8).x0,D(1,8).y0)-(D(9,8).x1,D(9,8).y1),,%Black
   Graphic Box (D(2,1).x0,D(2,1).y0)-(D(2,9).x1,D(2,9).y1),,%Black
   Graphic Box (D(5,1).x0,D(5,1).y0)-(D(5,9).x1,D(5,9).y1),,%Black
   Graphic Box (D(8,1).x0,D(8,1).y0)-(D(8,9).x1,D(8,9).y1),,%Black
   'Big lines
   Graphic Width 5
   Graphic Box (D(1,1).x0,D(1,1).y0)-(D(9,9).x1,D(9,9).y1),,%Black  'around game
   Graphic Box (D(4,1).x0,D(4,1).y0)-(D(6,9).x1,D(6,9).y1),,%Black
   Graphic Box (D(1,4).x0,D(1,4).y0)-(D(9,6).x1,D(9,6).y1),,%Black
   Graphic Width 4
End Sub

Sub DrawBigNumbers
   If Debug Then Txt.Print FuncName$
   Local i,j,x,y,w,h,wOffset,hOffset As Long
   Graphic Set Font hFont
   Graphic Text Size "8" To w,h
   wOffset = ((D(1,1).x1-D(1,1).x0)-w)/2
   hOffset = ((D(1,1).y1-D(1,1).y0)-h)/2
   For i = 1 To 9 : For j = 1 To 9
      If D(i,j).number = 0 Then Iterate For
      x = D(i,j).x0 + wOffset
      y = D(i,j).y0 + hOffset
      Graphic Set Pos (x,y)
      Graphic Color D(i,j).bignumbercolor, D(i,j).bgcolor
      Graphic Color D(i,j).bignumbercolor, D(i,j).bgcolor
      Graphic Print Format$(D(i,j).number,"0")
   Next j : Next i
End Sub

Sub DrawSmallNumbers
   If Debug Then Txt.Print FuncName$
   Local i,j,k,w,h,wOffset,hOffset As Long
   Graphic Set Font hFontS
   Graphic Text Size " 8 " To w,h
   wOffset = (D(1,1).x1 - D(1,1).x0 - 3*w ) / 2
   hOffset = (D(1,1).y1 - D(1,1).y0 - 3*h ) / 2
   For i = 1 To 9 : For j = 1 To 9
      If D(i,j).number Then Iterate For
      For k = 1 To 9
         If ShowSuggest And (D(i,j).suggeststatus(k)=0) Then
            Graphic Set Font hFontS
            Graphic Set Pos (D(i,j).noterect(k).nLeft,D(i,j).noterect(k).nTop)
            Graphic Color D(i,j).suggestcolor(k), D(i,j).bgcolor
            Graphic Print Str$(k)
         ElseIf ShowNotes Then
            Graphic Set Font IIf(D(i,j).notestatus(k),hFontSB,hFontS)
            Graphic Set Pos (D(i,j).noterect(k).nLeft,D(i,j).noterect(k).nTop)
            Graphic Color IIf(D(i,j).notestatus(k), NoteColor, NoteGrayColor), D(i,j).bgcolor
            Graphic Print Str$(k)
         End If
      Next k
   Next j : Next i
End Sub

Sub DrawSelection
   If Debug Then Txt.Print FuncName$
   Graphic Width 5
   Graphic Box (D(SX,SY).x0,D(SX,SY).y0)  -  (D(SX,SY).x1,D(SX,SY).y1),, SelectionColor
   Graphic Width 4
End Sub

Sub BuildAcceleratorTable
   If Debug Then Txt.Print FuncName$
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(35)
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_0 : ac(c).cmd   = %IDM_0  : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_1 : ac(c).cmd   = %IDM_1  : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_2 : ac(c).cmd   = %IDM_2  : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_3 : ac(c).cmd   = %IDM_3  : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_4 : ac(c).cmd   = %IDM_4  : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_5 : ac(c).cmd   = %IDM_5  : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_6 : ac(c).cmd   = %IDM_6  : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_7 : ac(c).cmd   = %IDM_7  : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_8 : ac(c).cmd   = %IDM_8  : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_9 : ac(c).cmd   = %IDM_9  : Incr c

   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_A  : ac(c).cmd  = %IDM_SetAspectRatio : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_C  : ac(c).cmd  = %IDM_Copy           : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E  : ac(c).cmd  = %IDM_Reveal         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_I  : ac(c).cmd  = %IDM_Information    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T  : ac(c).cmd  = %IDM_Test           : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P  : ac(c).cmd  = %IDM_Print          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R  : ac(c).cmd  = %IDM_Reset          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S  : ac(c).cmd  = %IDM_AllowSpeech    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z  : ac(c).cmd  = %IDT_Undo           : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D  : ac(c).cmd  = %IDM_Debug          : Incr c

   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Up    : ac(c).cmd   = %IDM_Up    : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Down  : ac(c).cmd   = %IDM_Down  : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Left  : ac(c).cmd   = %IDM_Left  : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Right : ac(c).cmd   = %IDM_Right : Incr c

   'Jim Robinson suggestion
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_SPACE   : ac(c).cmd   = %IDM_0  : Incr c   '
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_NUMPAD0 : ac(c).cmd   = %IDM_0  : Incr c   '
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_NUMPAD1 : ac(c).cmd   = %IDM_1  : Incr c   '
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_NUMPAD2 : ac(c).cmd   = %IDM_2  : Incr c   '
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_NUMPAD3 : ac(c).cmd   = %IDM_3  : Incr c   '
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_NUMPAD4 : ac(c).cmd   = %IDM_4  : Incr c   '
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_NUMPAD5 : ac(c).cmd   = %IDM_5  : Incr c   '
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_NUMPAD6 : ac(c).cmd   = %IDM_6  : Incr c   '
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_NUMPAD7 : ac(c).cmd   = %IDM_7  : Incr c   '
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_NUMPAD8 : ac(c).cmd   = %IDM_8  : Incr c   '
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_NUMPAD9 : ac(c).cmd   = %IDM_9  : Incr c   '

   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function RuleCheck(n As Long, SaveN As Long) As Long
   If Debug Then Txt.Print FuncName$
   Local x,y,OldD As Long
   'user has entered a value for a cell.

   If D(SX,SY).type = %Orig Then
      If AllowSpeech Then
         ReadText "This is a puzzle cell. It cannot be changed!"
      Else
         Beep
      End If
      Function = 0
      Exit Function  'cannot change
   End If

   'store old values
   OldD = D(SX,SY).number
   D(SX,SY).number = n   'undo later if need be

   If AllowAlerts = 0 Then GoTo NoAlerts

   'test to see if valid entry in rows
   For y = 1 To 9
      ReDim T(9) As Long
      For x = 1 To 9
         If D(x,y).number = 0 Then Iterate For
         Incr T(D(x,y).number)
         If T(D(x,y).number)> 1 Then
            D(SX,SY).number = OldD
            If HighlightError Then Graphic Box (D(1,y).x0,D(1,y).y0)-(D(9,y).x1,D(9,y).y1),,%Red : Graphic ReDraw
            If AllowSpeech Then
               sndPlaySound Choose$(n,"x1","x2","x3","x4","x5","x6","x7","x8","x9"),%Snd_Sync Or %SND_Resource
               ReadText " is already used in row "
               sndPlaySound Choose$(y,"x1","x2","x3","x4","x5","x6","x7","x8","x9"),%Snd_Sync Or %SND_Resource
            Else
               Beep
               If HighlightError Then Sleep 1000
            End If
            DrawPuzzle
            Function = 0
            Exit Function
         End If
      Next x
   Next y
   Function = 1

   'test to see if valid entry in columns
   For x = 1 To 9
      ReDim T(9) As Long
      For y = 1 To 9
         If D(x,y).number = 0 Then Iterate For
         Incr T(D(x,y).number)
         If T(D(x,y).number)> 1 Then
            D(SX,SY).number = OldD
            If HighlightError Then Graphic Box (D(x,1).x0,D(x,1).y0)-(D(x,9).x1,D(x,9).y1),,%Red : Graphic ReDraw
            If AllowSpeech Then
               sndPlaySound Choose$(n,"x1","x2","x3","x4","x5","x6","x7","x8","x9"),%Snd_Sync Or %SND_Resource
               ReadText " is already used in column "
               sndPlaySound Choose$(x,"x1","x2","x3","x4","x5","x6","x7","x8","x9"),%Snd_Sync Or %SND_Resource
            Else
               Beep
               If HighlightError Then Sleep 1000
            End If
            DrawPuzzle
            Function = 0
            Exit Function
         End If
      Next x
   Next y

   'test to see if valid entry in boxes
   ReDim BT(9,9) As Long    'BT(Box,Number)
   For x = 1 To 9
      For y = 1 To 9
         If D(x,y).number = 0 Then Iterate For
         Incr BT(D(x,y).Box,D(x,y).number)
         If BT(D(x,y).Box,D(x,y).number) > 1 Then
            D(SX,SY).number = OldD
            If HighlightError Then Graphic Box (sBox(D(x,y).Box).x0,sBox(D(x,y).Box).y0)-(sBox(D(x,y).Box).x1,sBox(D(x,y).Box).y1),,%Red : Graphic ReDraw
            If AllowSpeech Then
               sndPlaySound Choose$(n,"x1","x2","x3","x4","x5","x6","x7","x8","x9"),%Snd_Sync Or %SND_Resource
               ReadText " is already used in box "
               sndPlaySound Choose$(D(x,y).Box,"x1","x2","x3","x4","x5","x6","x7","x8","x9"),%Snd_Sync Or %SND_Resource
            Else
               Beep
              If HighlightError Then Sleep 1000
            End If
            DrawPuzzle
            Function = 0
            Exit Function
         End If
      Next x
   Next y

NoAlerts:

   'save pre-change cell data to UndoData array
   If SaveN Then SetUndoData SX,SY

   'is valid, change D() settings are required
   D(SX,SY).number           = n
   D(SX,SY).bgColor          = UserCellColor
   D(SX,SY).bignumbercolor   = UserBigNumberColor
   For x = 1 To 9 : D(SX,SY).notecolor(x) = NoteGrayColor : Next x
   For x = 1 To 9 : D(SX,SY).suggestcolor(x) = SuggestColor : Next x

   Function = 1
End Function


Sub GameCheck
   If Debug Then Txt.Print FuncName$
   Local x,y As Long
   'puzzle ocmplete (no zeros)
   For x = 1 To 9
      For y = 1 To 9
         If D(x,y).number = 0 Then Exit Sub 'value zero, not a success
      Next y
   Next x
   'Default                      SystemStart
   'CriticalBatteryAlarm         SystemNotification
   'MailBeep                     SystemExit
   'WindowsLogon                 SystemExclamation
   'WindowsLogoff                SystemAsterisk
   If AllowSpeech Then
      ReadText "Congratulations! You have solved the Suduku puzzle!"
   Else
      sndPlaySound("MailBeep", %SND_Sync)   'play once, in background
   End If
End Sub

Sub ReadText (sText As String)
   If Debug Then Txt.Print FuncName$
   Local vRes, vTxt, vTime As Variant, oSp As Dispatch
   Let oSp = NewCom "SAPI.SpVoice"
   If IsFalse IsObject(oSp) Then Exit Sub
   vTxt = sText
   Object Call oSp.Speak(vTxt) To vRes
   vTime = -1 As Long
   Object Call oSp.WaitUntilDone(vTime) To vRes
End Sub

Sub CreateToolbarStuff
  If Debug Then Txt.Print FuncName$
    ImageList New Icon 24,24,24,10 To hImageList
    ImageList Add Icon hImageList, "logo"      '1
    ImageList Add Icon hImageList, "xreset"    '2
    ImageList Add Icon hImageList, "xsettings" '3
    ImageList Add Icon hImageList, "xhelp"     '4
    ImageList Add Icon hImageList, "x0"        '5
    ImageList Add Icon hImageList, "x1"        '6
    ImageList Add Icon hImageList, "x2"        '7
    ImageList Add Icon hImageList, "x3"        '8
    ImageList Add Icon hImageList, "x4"        '9
    ImageList Add Icon hImageList, "x5"        '10
    ImageList Add Icon hImageList, "x6"        '11
    ImageList Add Icon hImageList, "x7"        '12
    ImageList Add Icon hImageList, "x8"        '13
    ImageList Add Icon hImageList, "x9"        '14
    ImageList Add Icon hImageList, "xup"       '15
    ImageList Add Icon hImageList, "xdown"     '16
    ImageList Add Icon hImageList, "xleft"     '17
    ImageList Add Icon hImageList, "xright"    '18
    ImageList Add Icon hImageList, "xclear"    '19
    ImageList Add Icon hImageList, "xxprint"   '20
    ImageList Add Icon hImageList, "xreveal"   '21
    ImageList Add Icon hImageList, "xcandidates" '22
    ImageList Add Icon hImageList, "xcopy"     '23
    ImageList Add Icon hImageList, "xdraw"     '24
    ImageList Add Icon hImageList, "xundo"     '25
    ImageList Add Icon hImageList, "xredo"     '26
    ImageList Add Icon hImageList, "xcancelb"  '27
    ImageList Add Icon hImageList, "xempty"    '28
    ImageList Add Icon hImageList, "xaspect"   '29

    Menu New PopUp To hColors
    Menu Add String, hColors, "Puzzle Number Cell", %IDM_OrigCellColor, %MF_Enabled
    Menu Add String, hColors, "User Number Cell", %IDM_UserCellColor, %MF_Enabled
    Menu Add String, hColors, "Empty Cell", %IDM_EmptyCellColor, %MF_Enabled
    Menu Add String, hColors, "-",0,0
    Menu Add String, hColors, "Puzzle Number", %IDM_OrigBigNumberColor, %MF_Enabled
    Menu Add String, hColors, "User Number", %IDM_UserBigNumberColor, %MF_Enabled
    Menu Add String, hColors, "Suggested Numbers", %IDM_SuggestColor, %MF_Enabled
    Menu Add String, hColors, "Active Note Numbers", %IDM_NoteColor, %MF_Enabled
    Menu Add String, hColors, "InActive Note Numbers", %IDM_NoteGrayColor, %MF_Enabled
    Menu Add String, hColors, "-",0,0
    Menu Add String, hColors, "Cell Selection", %IDM_SelectionColor, %MF_Enabled
    Menu Add String, hColors, "-",0,0
    Menu Add String, hColors, "Restore Default Colors", %IDM_DefaultColors, %MF_Enabled


    Menu New PopUp To hSettings
    Menu Add String, hSettings, "Allow Speech", %IDM_AllowSpeech, %MF_Enabled
    Menu Add String, hSettings, "Ask Confirmation", %IDM_AskConfirmation, %MF_Enabled
    Menu Add String, hSettings, "Allow Alerts", %IDM_AllowAlerts, %MF_Enabled
    Menu Add String, hSettings, "Save Session", %IDM_AutoSave, %MF_Enabled
    Menu Add String, hSettings, "Highlight Error", %IDM_HighlightError, %MF_Enabled
    Menu Add String, hSettings, "Landscape Printing", %IDM_Landscape, %MF_Enabled
    Menu Add String, hSettings, "Show Caption Information", %IDM_ShowCaption, %MF_Enabled
    Menu Add String, hSettings, "Allow Drag Number Entry", %IDM_AllowDragNumber, %MF_Enabled
    Menu Add String, hSettings, "Compact Toolbar", %IDM_CompactToolbar, %MF_Enabled
'    Menu Add String, hSettings, "Maintain 1:1 Aspect Ratio", %IDM_MaintainAR, %MF_Enabled
    Menu Add String, hSettings, "-",0,0
    Menu Add String, hSettings, "Print Game", %IDM_Print, %MF_Enabled
    Menu Add String, hSettings, "Copy Game", %IDM_Copy, %MF_Enabled
    Menu Add String, hSettings, "Display Information", %IDM_Information, %MF_Enabled
    Menu Add PopUp,  hSettings, "Set Colors", hColors, %MF_Enabled

    Menu New PopUp To hHelp
    Menu Add String, hHelp, "Local Help",  %IDM_LocalHelp,  %MF_Enabled
    Menu Add String, hHelp, "Online Update",  %IDM_OnlineUpdate,  %MF_Enabled
End Sub

Sub CreateToolbarsOnly
    'Top toolbar
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist
    'Bottom toolbar
    Control Add Toolbar, hDlg, %IDC_ToolbarB,"", 0,60,0,0, %CCS_NoMoveY Or %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_ToolbarB To hToolbarB
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_ToolbarB, hImageList, 0     'default imagelist

    If CompactToolbar Then
       Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_New,  %TbStyle_Button, "New"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Reset,  %TbStyle_Button, "Reset"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 19, %IDT_Clear,  %TbStyle_Button, "Clear"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 21, %IDT_Reveal,  %TbStyle_Button, "Reveal"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 10
       Toolbar Add Button  hDlg, %IDC_Toolbar, 25, %IDT_Undo,  %TbStyle_Button, "Undo"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 26, %IDT_Redo,  %TbStyle_Button, "Redo"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 10
       Toolbar Add Button  hDlg, %IDC_Toolbar, 29, %IDT_Aspect,  %TbStyle_Button, "Aspect"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Options"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Help,  %TbStyle_Button Or %TbStyle_DropDown, "Help"

       Toolbar Add Separator hDlg, %IDC_ToolbarB, 20
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 27, %IDT_0,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 6, %IDT_1,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 7, %IDT_2,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 8, %IDT_3,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 9, %IDT_4,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 10, %IDT_5,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 11, %IDT_6,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 12, %IDT_7,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 13, %IDT_8,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 14, %IDT_9,  %TbStyle_Button, ""
    Else
       Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_New,  %TbStyle_Button, "New"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Reset,  %TbStyle_Button, "Reset"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 19, %IDT_Clear,  %TbStyle_Button, "Clear"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 21, %IDT_Reveal,  %TbStyle_Button, "Reveal"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 10
       Toolbar Add Button  hDlg, %IDC_Toolbar, 25, %IDT_Undo,  %TbStyle_Button, "Undo"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 26, %IDT_Redo,  %TbStyle_Button, "Redo"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 10
       Toolbar Add Button  hDlg, %IDC_Toolbar, 20, %IDT_Print,  %TbStyle_Button, "Print"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 23, %IDT_Copy,  %TbStyle_Button, "Copy"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 10
       Toolbar Add Button  hDlg, %IDC_Toolbar, 28, %IDT_Empty,  %TbStyle_CheckGroup, "Empty"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 24, %IDT_Notes,  %TbStyle_CheckGroup, "Notes"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 22, %IDT_Suggest,  %TbStyle_CheckGroup, "Suggest"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 10
       Toolbar Add Button  hDlg, %IDC_Toolbar, 29, %IDT_Aspect,  %TbStyle_Button, "Aspect"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Help,  %TbStyle_Button Or %TbStyle_DropDown, "Help"

       Toolbar Add Separator hDlg, %IDC_ToolbarB, 40
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 27, %IDT_0,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 6, %IDT_1,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 7, %IDT_2,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 8, %IDT_3,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 9, %IDT_4,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 10, %IDT_5,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 11, %IDT_6,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 12, %IDT_7,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 13, %IDT_8,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 14, %IDT_9,  %TbStyle_Button, ""
       Toolbar Add Separator hDlg, %IDC_ToolbarB, 10
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 15, %IDT_Up,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 16, %IDT_Down,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 17, %IDT_Left,  %TbStyle_Button, ""
       Toolbar Add Button  hDlg, %IDC_ToolbarB, 18, %IDT_Right,  %TbStyle_Button, ""
   End If
End Sub


Function SetToolTips(cID As Long) As String
'   If Debug Then Txt.Print FuncName$   '<--- disabled by choice
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_New         : Function = "New Game"
      Case %IDT_Reset       : Function = "Remove User-Entered Values"
      Case %IDT_Clear       : Function = "Clear All Values"
      Case %IDT_Reveal      : Function = "Reveal Solution for Selected Cell"
      Case %IDT_Undo        : Function = "Undo Last Cell Assignment"
      Case %IDT_Redo        : Function = "Redo Next Cell Assignment"
      Case %IDT_Print       : Function = "Print Game to Selected Printer"
      Case %IDT_Copy        : Function = "Copy Sudoku to Clipboard"
      Case %IDT_Empty       : Function = "Hide Notes/Suggestions"
      Case %IDT_Notes       : Function = "Display User Notes"
      Case %IDT_Suggest     : Function = "Display Suggested Cell Numbers"
      Case %IDT_Aspect      : Function = "Set Game to 1:1 Aspect Ratio"
      Case %IDT_Settings    : Function = "Options"
      Case %IDT_Help        : Function = "Open Online Help"

      Case %IDT_0           : Function = "Remove Number from Cell"
      Case %IDT_1 To %IDT_9 : Function = "Set Selected Cell to " + Str$(cID - %IDT_0)
      Case %IDT_Up          : Function = "Move to Cell One Position Up"
      Case %IDT_Down        : Function = "Move to Cell One Postion Down"
      Case %IDT_Left        : Function = "Move to Cell One Position to the Left"
      Case %IDT_Right       : Function = "Move to Cell One Position to the Right"
   End Select
End Function

Sub Settings_INI(Task$)
   If Debug Then Txt.Print FuncName$
   Local x,y,w,h,wDesk,hDesk As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "666", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "788", yResult, %Max_Path, INIFileName
      w = Val(xResult) : h = Val(yResult)
      Dialog Set Size hDlg,w,h

      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "-1", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "-1", yResult, %Max_Path, INIFileName
      If Val(xResult) = -1 Then
         Desktop Get Client To wDesk,hDesk
         Dialog Set Loc hDlg, (wDesk-w)/2, (hDesk-h)/2
      Else
         Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top
      End If

     'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "SX", "1", temp, %Max_Path, INIFileName:  SX = Val(temp)
      Getprivateprofilestring "All", "SY", "1", temp, %Max_Path, INIFileName:  SY = Val(temp)
      Getprivateprofilestring "All", "AllowSpeech", "1", temp, %Max_Path, INIFileName:  AllowSpeech = Val(temp)
      Getprivateprofilestring "All", "ShowCaption", "1", temp, %Max_Path, INIFileName:  ShowCaption = Val(temp)
      Getprivateprofilestring "All", "AskConfirmation", "1", temp, %Max_Path, INIFileName:  AskConfirmation = Val(temp)
      Getprivateprofilestring "All", "AllowAlerts", "1", temp, %Max_Path, INIFileName:  AllowAlerts = Val(temp)
      Getprivateprofilestring "All", "CompactToolbar", "0", temp, %Max_Path, INIFileName:  CompactToolbar = Val(temp)
      Getprivateprofilestring "All", "AutoSave", "1", temp, %Max_Path, INIFileName:  AutoSave = Val(temp)
      Getprivateprofilestring "All", "HighlightError", "1", temp, %Max_Path, INIFileName: HighlightError = Val(temp)
      Getprivateprofilestring "All", "Landscape", "0", temp, %Max_Path, INIFileName:  Landscape = Val(temp)
      Getprivateprofilestring "All", "TBM", "100", temp, %Max_Path, INIFileName:  TBM = Val(temp)
      Getprivateprofilestring "All", "StartQty", "40", temp, %Max_Path, INIFileName:  StartQty = Val(temp)
      Getprivateprofilestring "All", "AllowDragNumber", "0", temp, %Max_Path, INIFileName:  AllowDragNumber = Val(temp)
      Getprivateprofilestring "All", "ShowNotes", "0", temp, %Max_Path, INIFileName:  ShowNotes = Val(temp)
      Getprivateprofilestring "All", "ShowSuggest", "0", temp, %Max_Path, INIFileName:  ShowSuggest = Val(temp)
      Getprivateprofilestring "All", "ShowEmpty", "1", temp, %Max_Path, INIFileName:  ShowEmpty = Val(temp)
      Getprivateprofilestring "All", "MaintainAR", "1", temp, %Max_Path, INIFileName:  MaintainAR = Val(temp)
      Getprivateprofilestring "All", "UndoPos", "0", temp, %Max_Path, INIFileName:  UndoPos = Val(temp)
      Getprivateprofilestring "All", "MaxUndoPos", "0", temp, %Max_Path, INIFileName:  MaxUndoPos = Val(temp)

      Getprivateprofilestring "All", "OrigCellColor", Str$(%rgb_Wheat), temp, %Max_Path, INIFileName:  OrigCellColor = Val(temp)
      Getprivateprofilestring "All", "UserCellColor", Str$(%rgb_SkyBlue), temp, %Max_Path, INIFileName:  UserCellColor = Val(temp)
      Getprivateprofilestring "All", "EmptyCellColor", Str$(%White), temp, %Max_Path, INIFileName:  EmptyCellColor = Val(temp)

      Getprivateprofilestring "All", "OrigBigNumberColor", Str$(%Black), temp, %Max_Path, INIFileName:  OrigBigNumberColor = Val(temp)
      Getprivateprofilestring "All", "UserBigNumberColor", Str$(%Black), temp, %Max_Path, INIFileName:  UserBigNumberColor = Val(temp)
      Getprivateprofilestring "All", "SuggestColor", Str$(%Red), temp, %Max_Path, INIFileName:  SuggestColor = Val(temp)
      Getprivateprofilestring "All", "NoteColor", Str$(%rgb_DarkBlue), temp, %Max_Path, INIFileName:  NoteColor = Val(temp)
      Getprivateprofilestring "All", "NoteGrayColor", Str$(RGB(180,180,180)), temp, %Max_Path, INIFileName:  NoteGrayColor = Val(temp)

      Getprivateprofilestring "All", "SelectionColor", Str$(%Red), temp, %Max_Path, INIFileName:  SelectionColor = Val(temp)

      Getprivateprofilestring "All", "Edge", "10", temp, %Max_Path, INIFileName:  Edge = Val(temp)

      For x = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", Str$(FontSize), INIFileName
      WritePrivateProfileString "All", "FontAttr", Str$(FontAttr), INIFileName
      WritePrivateProfileString "All", "SX", Str$(SX), INIFileName
      WritePrivateProfileString "All", "SY", Str$(SY), INIFileName
      WritePrivateProfileString "All", "AllowSpeech", Str$(AllowSpeech), INIFileName
      WritePrivateProfileString "All", "ShowCaption", Str$(ShowCaption), INIFileName
      WritePrivateProfileString "All", "AskConfirmation", Str$(AskConfirmation), INIFileName
      WritePrivateProfileString "All", "AllowAlerts", Str$(AllowAlerts), INIFileName
      WritePrivateProfileString "All", "CompactToolbar", Str$(CompactToolbar), INIFileName
      WritePrivateProfileString "All", "AutoSave", Str$(AutoSave), INIFileName
      WritePrivateProfileString "All", "HighlightError", Str$(HighlightError), INIFileName
      WritePrivateProfileString "All", "Landscape", Str$(LandScape), INIFileName
      WritePrivateProfileString "All", "TBM", Str$(TBM), INIFileName
      WritePrivateProfileString "All", "StartQty", Str$(StartQty), INIFileName
      WritePrivateProfileString "All", "AllowDragNumber", Str$(AllowDragNumber), INIFileName
      WritePrivateProfileString "All", "ShowNotes", Str$(ShowNotes), INIFileName
      WritePrivateProfileString "All", "ShowSuggest", Str$(ShowSuggest), INIFileName
      WritePrivateProfileString "All", "ShowEmpty", Str$(ShowEmpty), INIFileName
      WritePrivateProfileString "All", "MaintainAR", Str$(MaintainAR), INIFileName
      WritePrivateProfileString "All", "UndoPos", Str$(UndoPos), INIFileName
      WritePrivateProfileString "All", "MaxUndoPos", Str$(MaxUndoPos), INIFileName

      WritePrivateProfileString "All", "OrigCellColor", Str$(OrigCellColor), INIFileName
      WritePrivateProfileString "All", "UserCellColor", Str$(UserCellColor), INIFileName
      WritePrivateProfileString "All", "EmptyCellColor", Str$(EmptyCellColor), INIFileName

      WritePrivateProfileString "All", "OrigBigNumberColor", Str$(OrigBigNumberColor), INIFileName
      WritePrivateProfileString "All", "UserBigNumberColor", Str$(UserBigNumberColor), INIFileName
      WritePrivateProfileString "All", "SuggestColor", Str$(SuggestColor), INIFileName
      WritePrivateProfileString "All", "NoteColor", Str$(NoteColor), INIFileName
      WritePrivateProfileString "All", "NoteGrayColor", Str$(NoteGrayColor), INIFileName

      WritePrivateProfileString "All", "SelectionColor", Str$(SelectionColor), INIFileName

      WritePrivateProfileString "All", "Edge", Str$(Edge), INIFileName

      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(x,"00"), temp, INIFileName
      Next

      End If
End Sub

Sub SetMenusAndToolbar
   If Debug Then Txt.Print FuncName$
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Notes, ShowNotes * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Suggest, ShowSuggest * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Empty, ShowEmpty * %TBState_Checked Or %TBState_Enabled

   'Menus
    Menu Set State hSettings, ByCmd %IDM_AllowSpeech, AllowSpeech * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_ShowCaption, ShowCaption * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AskConfirmation, AskConfirmation * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AllowAlerts, AllowAlerts * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_CompactToolbar, CompactToolbar * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AutoSave, AutoSave * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_Highlighterror, HighlightError * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_Landscape, Landscape * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_MaintainAR, MaintainAR * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AllowDragNumber, AllowDragNumber * %MFS_Checked Or %MFS_Enabled

    Menu Set State hContext, ByCmd %IDM_Empty, ShowEmpty * %MFS_Checked Or %MFS_Enabled
    Menu Set State hContext, ByCmd %IDM_Notes, ShowNotes * %MFS_Checked Or %MFS_Enabled
    Menu Set State hContext, ByCmd %IDM_Suggest, ShowSuggest * %MFS_Checked Or %MFS_Enabled
End Sub

Function ListCandidates(ArrayIndex As Integer) As String
'   If Debug Then Txt.Print FuncName$   '<--- disabled by choice
   Local i,j,k,RowIndex,ColumnIndex,BoxStartIndex,inx,arrSS() As Integer, temp$

   ReDim arrSS(9) 'Boolean array : True=Symbol reserved, False=Possible Candidate
   'Convert array index into a table index
   RowIndex = Int(ArrayIndex / 9)
   ColumnIndex = ArrayIndex - (RowIndex * 9)

   For j = 1 To 9 'Loop symbols 1 to 9
       arrSS(j) = %False 'default
       'Check Puzzle Row for available candidates
       For i = (RowIndex * 9) To ((RowIndex * 9) + 8)
         If arrSudoku(i) = j Then
           arrSS(j) = %True 'Reserved
         End If
       Next
       'Check Puzzle Column for available candidates
       For i = ColumnIndex To (72 + ColumnIndex) Step 9
         If arrSudoku(i) = j Then
           arrSS(j) = %True 'Reserved
         End If
       Next
   Next

   'Check Box (3*3 grid) for available candidates
   BoxStartIndex = (Int(ArrayIndex / 27) * 27) + (Int(ColumnIndex / 3) * 3)

   For i = 0 To 2 'Row counter
     For j = 0 To 2 'Column counter
        inx = BoxStartIndex + (i * 9) + j
        For k = 1 To 9 'Loop symbols 1 to 9
           If arrSudoku(inx) = k Then
               arrSS(k) = %True 'Reserved
           End If
        Next
     Next
   Next

   'Return candidates in a string
   For i = 1 To 9
       If arrSS(i) = %False Then temp$ = temp$ + Format$(i,"0")
   Next
   Function = temp$
End Function

Sub CreateSudoku()
   If Debug Then Txt.Print FuncName$
   Local i,j,LeastInCell,Least,SymbolCounter,CandidateCount As Integer
   Local Candidates, temp As String

   Do
     ReDim arrSudoku(80) 'Clear the Sudoku Array
     SymbolCounter = 0 'Reset symbol counter
     For j = 1 To 81 'We need all the 81 symbols for a standard 9*9 Sudoku

       Least = 10 'Seed value (higher than nbr of possible candidates, i.e. 9)

       For i = 0 To 80 'Loop Sudoku array to find a cell w/ lowest nbr of candidates
         If arrSudoku(i) = 0 Then 'Empty cell - check the candidates
            Temp = ListCandidates(i) 'Save found candidates in a temp string
            CandidateCount = Len(Temp) 'Check the number of found candidates
            '----------------------------------------------------------------
            'In a case no candidates are found, we have a conflicting
            'situation, i.e. puzzle is not valid - let's skip the loop
            'and try again
            If CandidateCount = 0 Then GoTo OOPS
            '----------------------------------------------------------------
            If CandidateCount < Least Then 'Cell has lower nbr of candidates
                Least = CandidateCount 'Save lowest candidate count
                Candidates = Temp 'Save found Candidates string
                LeastInCell = i 'Save array index
            End If
         End If
       Next 'Sudoku array index

       'Update the Sudoku array
       Select Case Len(Candidates)
           'One candidate found, we have to use that
           Case 1: arrSudoku(LeastInCell) = Val(Candidates)
           'Several candidates, let's pick one randomly
           Case Else: arrSudoku(LeastInCell) = Val(Mid$(Candidates, Rnd(1, Least), 1))
       End Select
     Next

     'Check the number of symbols found so far ...
     For i = 0 To 80
       If arrSudoku(i) > 0 Then SymbolCounter = SymbolCounter + 1
     Next
OOPS:
     'Loop until when we have all the symbols filled in
   Loop Until SymbolCounter = 81

End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$   '<--- disabled by choice
   Local x As Long, y As Long    'MsgBox is approximately 200x200
   CenterOverDialog 200,200,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   If Debug Then Txt.Print FuncName$
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub

Sub PrintGame
   If Debug Then Txt.Print FuncName$
   Local x,y,wNew,hNew,wImg,hImg,wCont,hCont As Long
   Local hDC_Dialog, hBMP_Dialog, hDC_Graphic As Dword

   XPrint Attach Choose
   If Len(XPrint$)=0 Then Exit Sub
   XPrint Set Orientation IIf(Landscape,2,1)

   Dialog Get Size hDlg To wImg,hImg
   hDC_Dialog = GetWindowDC (hDlg)
   Graphic Bitmap New wImg,hImg To hBMP_Dialog
   Graphic Attach hBMP_Dialog, 0
   Graphic Get DC To hDC_Graphic
   BitBlt hDC_Graphic, 0,0,wImg,hImg, hDC_Dialog, 0,0, %SRCCopy
   ReleaseDC hDlg, hDC_Dialog  'PowerBASIC handles release of hDC_Graphic

   XPrint Get Client To wCont, hCont

   'wCont,hCont = container size : hImg,wImg = original image size : wNew,hNew = image size to fit in container
   wNew = wImg / Max(wImg / wCont, hImg / hCont)
   hNew = hImg / Max(wImg / wCont, hImg / hCont)
   x = (wCont-wNew)/2 : y = (hCont-hNew)/2               'upper/left position so resized image is centered
   XPrint Stretch hBMP_Dialog, 0, (0,0)-(wImg-1,hImg-1) To (x,y)-(x+wNew-1,y+hNew-1)  'copy (resized) from memory bitmap to visible image
   XPrint Close

End Sub

Sub CreateSubFolders
   If Debug Then Txt.Print FuncName$
   If IsFolder (Exe.Path$ + "files") = %False Then MkDir Exe.Path$ + "files"
   If IsFolder (Exe.Path$ + "images") = %False Then MkDir Exe.Path$ + "images"
   If IsFolder (Exe.Path$ + "games") = %False Then MkDir Exe.Path$ + "games"
End Sub

Sub SaveSession
   If Debug Then Txt.Print FuncName$
   Open $SessionFile For Binary As #1
   Put #1,,D()
   Put #1,,arrSudoku()
   Put #1,,UndoData()
   Close #1
End Sub

Sub LoadSession
   If Debug Then Txt.Print FuncName$
   Open $SessionFile For Binary As #1
   Get #1,,D()
   Get #1,,arrSudoku()
   Get #1,,UndoData()
   Close #1
End Sub

Sub DisplayDData
   If Debug Then Txt.Print FuncName$
   Local x,y As Long
   Open "files\temp.txt" For Output As #1
   Print #1, "xy" + $Tab + "ID" + $Tab + "Num" + $Tab + "Box" + $Tab + " x0" + $Tab + " y0" + $Tab + " x1" + $Tab + " y1" + $Tab + "type" + $Tab + " bgColor" + $Tab + _
             $Tab + "numclr" + $Tab + " 1 2 3 suggest 8 9" + $Tab + " 1 2 3 notes 7 8 9"
   For x = 1 To 9
      For y = 1 To 9
         Print #1, LTrim$(Str$(x)) + Str$(y) + $Tab ;
         Print #1, Str$((x-1)*9+y) + $Tab ;
         Print #1, Str$(D(x,y).number) + $Tab ;
         Print #1, Str$(D(x,y).box) + $Tab ;
         Print #1, Str$(D(x,y).x0) + $Tab ;
         Print #1, Str$(D(x,y).y0) + $Tab ;
         Print #1, Str$(D(x,y).x1) + $Tab ;
         Print #1, Str$(D(x,y).y1) + $Tab ;
         Print #1, IIf$(D(x,y).type=%User, "User","Orig") + $Tab;
         Print #1, Str$(D(x,y).bgcolor) + $Tab ;
         Print #1, Str$(D(x,y).bignumbercolor) + $Tab ;

         Print #1, Str$(D(x,y).suggeststatus(1)) + Str$(D(x,y).suggeststatus(2)) + Str$(D(x,y).suggeststatus(3)) ;
         Print #1, Str$(D(x,y).suggeststatus(4)) + Str$(D(x,y).suggeststatus(5)) + Str$(D(x,y).suggeststatus(6)) ;
         Print #1, Str$(D(x,y).suggeststatus(7)) + Str$(D(x,y).suggeststatus(8)) + Str$(D(x,y).suggeststatus(9)) + $Tab ;

         Print #1, Str$(D(x,y).notestatus(1)) + Str$(D(x,y).notestatus(2)) + Str$(D(x,y).notestatus(3)) ;
         Print #1, Str$(D(x,y).notestatus(4)) + Str$(D(x,y).notestatus(5)) + Str$(D(x,y).notestatus(6)) ;
         Print #1, Str$(D(x,y).notestatus(7)) + Str$(D(x,y).notestatus(8)) + Str$(D(x,y).notestatus(9))
      Next y
   Next x

   'Also display undo stack
   Print #1 : Print #1 : Print #1 : Print #1
   Print #1, "UndoPos" + $Tab + "MaxUndoPos)
   Print #1, Str$(UndoPos) + $Tab + Str$(MaxUndoPos) + $CrLf
   Print #1, " x" + $Tab + " y" + $Tab + " n"
   For x = 0 To UndoPos
      Print #1, Str$(UndoData(x).x) + $Tab + Str$(UndoData(x).y) + $Tab + Str$(UndoData(x).n)
   Next i

   Close #1

   x  = Shell ("Notepad " + Exe.Path$ + "files\temp.txt", 1)  'opens Notepad, does not wait for it to close
End Sub

Sub GetDebug
'   If Debug Then Txt.Print FuncName$   '<--- disabled by choice
   Local temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   Getprivateprofilestring "All", "Debug", "0", temp, %Max_Path, INIFileName:  Debug = Val(temp)
End Sub

Sub BuildCellCoordinates
   If Debug Then Txt.Print FuncName$
   Local i,j,x,y,wCell,hCell,w,h  As Long
   Graphic Get Client To w,h
   wCell = (w-2*Edge)/9 : hCell = (h-2*Edge)/9

   'Cell boundaries - x0 y0 x1 y1
   For i = 1 To 9
      x = Edge + (i-1) * wCell
      For j = 1 To 9
         y = Edge + (j-1) * hCell
         D(i,j).x0 = x       : D(i,j).y0 = y       'upper left
         D(i,j).x1 = x+wCell : D(i,j).y1 = y+hCell 'lower right
      Next x
    Next y

   'Box boundaries
   BuildBoxBoundaries

   'Note boundaries
   BuildNoteBoundaries
End Sub

Sub BuildNoteBoundaries
   If Debug Then Txt.Print FuncName$
   Local i,j,k,w,h,wOffset,hOffset As Long
   Graphic Set Font hFontS
   Graphic Text Size " 8 " To w,h
   wOffset = (D(1,1).x1 - D(1,1).x0 - 3*w ) / 2
   hOffset = (D(1,1).y1 - D(1,1).y0 - 3*h ) / 2
   For i = 1 To 9 : For j = 1 To 9
      If D(i,j).type = %Orig Then Iterate For
      D(i,j).noterect(1).nLeft = D(i,j).x0 + wOffset        :  D(i,j).noterect(1).nTop = D(i,j).y0 + hOffset
      D(i,j).noterect(2).nLeft = D(i,j).x0 + wOffset + w    :  D(i,j).noterect(2).nTop = D(i,j).y0 + hOffset
      D(i,j).noterect(3).nLeft = D(i,j).x0 + wOffset + 2*w  :  D(i,j).noterect(3).nTop = D(i,j).y0 + hOffset
      D(i,j).noterect(4).nLeft = D(i,j).x0 + wOffset        :  D(i,j).noterect(4).nTop = D(i,j).y0 + hOffset + h
      D(i,j).noterect(5).nLeft = D(i,j).x0 + wOffset + w    :  D(i,j).noterect(5).nTop = D(i,j).y0 + hOffset + h
      D(i,j).noterect(6).nLeft = D(i,j).x0 + wOffset + 2*w  :  D(i,j).noterect(6).nTop = D(i,j).y0 + hOffset + h
      D(i,j).noterect(7).nLeft = D(i,j).x0 + wOffset        :  D(i,j).noterect(7).nTop = D(i,j).y0 + hOffset + 2*h
      D(i,j).noterect(8).nLeft = D(i,j).x0 + wOffset + w    :  D(i,j).noterect(8).nTop = D(i,j).y0 + hOffset + 2*h
      D(i,j).noterect(9).nLeft = D(i,j).x0 + wOffset + 2*w  :  D(i,j).noterect(9).nTop = D(i,j).y0 + hOffset + 2*h
      For k = 1 To 9
         D(i,j).noterect(k).nRight  = D(i,j).noterect(k).nLeft + w
         D(i,j).noterect(k).nBottom = D(i,j).noterect(k).nTop + h
      Next k
   Next j : Next i
End Sub

Sub BuildBoxBoundaries
   If Debug Then Txt.Print FuncName$
   sBox(1).x0 = D(1,1).x0 : sBox(1).y0 = D(1,1).y0 : sBox(1).x1 = D(3,3).x1 : sBox(1).y1 = D(3,3).y1
   sBox(2).x0 = D(4,1).x0 : sBox(2).y0 = D(4,1).y0 : sBox(2).x1 = D(6,3).x1 : sBox(2).y1 = D(6,3).y1
   sBox(3).x0 = D(7,1).x0 : sBox(3).y0 = D(7,1).y0 : sBox(3).x1 = D(9,3).x1 : sBox(3).y1 = D(9,3).y1
   sBox(4).x0 = D(1,4).x0 : sBox(4).y0 = D(1,4).y0 : sBox(4).x1 = D(3,6).x1 : sBox(4).y1 = D(3,6).y1
   sBox(5).x0 = D(4,4).x0 : sBox(5).y0 = D(4,4).y0 : sBox(5).x1 = D(6,6).x1 : sBox(5).y1 = D(6,6).y1
   sBox(6).x0 = D(7,4).x0 : sBox(6).y0 = D(7,4).y0 : sBox(6).x1 = D(9,6).x1 : sBox(6).y1 = D(9,6).y1
   sBox(7).x0 = D(1,7).x0 : sBox(7).y0 = D(1,7).y0 : sBox(7).x1 = D(3,9).x1 : sBox(7).y1 = D(3,9).y1
   sBox(8).x0 = D(4,7).x0 : sBox(8).y0 = D(4,7).y0 : sBox(8).x1 = D(6,9).x1 : sBox(8).y1 = D(6,9).y1
   sBox(9).x0 = D(7,7).x0 : sBox(9).y0 = D(7,7).y0 : sBox(9).x1 = D(9,9).x1 : sBox(9).y1 = D(9,9).y1
End Sub

Sub CreateEmptyD
   If Debug Then Txt.Print FuncName$
   Reset EmptyD
   EmptyD.type    = %User
   EmptyD.bgcolor  = EmptyCellColor
End Sub

Sub ClearDArray
   If Debug Then Txt.Print FuncName$
   Local i,j As Long
   'Clear D Array
   For i = 1 To 9 : For j = 1 To 9 : D(i,j) = EmptyD : Next j : Next i
End Sub

Sub SetNewGameCellProperites(LevelOfDifficulty As Long)
   If Debug Then Txt.Print FuncName$
   Local i,j,x,y As Long
   'Cell number, type, color, box
   For i = 0 To 80
      y = i \ 9 + 1
      x = i Mod 9 + 1
      If Rnd(1,100) < LevelOfDifficulty Then
         D(x,y).number   = arrSudoku(i)
         D(x,y).type     = %Orig
         D(x,y).bgcolor = OrigCellColor
      End If
      For j = 1 To 9
         D(x,y).suggeststatus(j) = 0 'all off
         D(x,y).suggestcolor(j) = SuggestColor
         D(x,y).notestatus(j) = 0    'all off
         D(x,y).notecolor(j) = NoteGrayColor
      Next j
      Select Case i+1
         Case 01,02,03,10,11,12,19,20,21 : D(x,y).box = 1
         Case 04,05,06,13,14,15,22,23,24 : D(x,y).box = 2
         Case 07,08,09,16,17,18,25,26,27 : D(x,y).box = 3

         Case 28,29,30,37,38,39,46,47,48 : D(x,y).box = 4
         Case 31,32,33,40,41,42,49,50,51 : D(x,y).box = 5
         Case 34,35,36,43,44,45,52,53,54 : D(x,y).box = 6

         Case 55,56,57,64,65,66,73,74,75 : D(x,y).box = 7
         Case 58,59,60,67,68,69,76,77,78 : D(x,y).box = 8
         Case 61,62,63,70,71,72,79,80,81 : D(x,y).box = 9
      End Select
   Next
End Sub

Sub GetCellCandidates
   If Debug Then Txt.Print FuncName$
   Local k,x,y  As Long

   'Clear All Candidates
   For x = 1 To 9
      For y = 1 To 9
         For k = 1 To 9
            D(x,y).suggeststatus(k) = 0
         Next k
      Next y
   Next x

   'check for existence in rows
   For x = 1 To 9  'row
      For y = 1 To 9 'col
         If D(x,y).number Then Iterate For
         'text each row
         For k = 1 To 9 'repeat for each column in row
            If D(x,k).number Then D(x,y).suggeststatus(D(x,k).number) = 1
         Next k
      Next y
   Next x

   'check for existence in columns
   For x = 1 To 9  'row
      For y = 1 To 9 'col
         If D(x,y).number Then Iterate For
         'test each col
         For k = 1 To 9 'repeat for each row in column
            If D(k,y).number Then D(x,y).suggeststatus(D(k,y).number) = 1
         Next k
      Next y
   Next x
   'boxes

   'check for existence in boxes
   ReDim BT(9,9) As Long    'BT(Box,Number)
   For y = 1 To 9
      For x = 1 To 9
         Incr BT(D(x,y).Box,D(x,y).number)
      Next y
   Next x

   For x = 1 To 9
      For y = 1 To 9
         For k = 1 To 9
            If BT(D(x,y).Box,k) Then D(x,y).suggeststatus(k) = 1
         Next k
      Next y
   Next x


End Sub

Sub GetCurrentXY(ptCursor As Point)
   If Debug Then Txt.Print FuncName$
   Local x,y As Single
   x = (ptCursor.x-Edge)/(D(9,1).x1-D(1,1).x0) / .111 + 1
   SX = Min(9,Max(1,Fix(x)))
   y = (ptCursor.y-TBM-Edge)/(D(1,9).y1-D(1,1).y0) / .111 + 1
   SY = Min(9,Max(1,Fix(y)))
End Sub

Function SetBigFont() As Long
   If Debug Then Txt.Print FuncName$
   Local x,y,w,h,fSize As Long, Factor As Single
   Factor = 0.80
   w = D(1,1).x1 - D(1,1).x0
   h = D(1,1).y1 - D(1,1).y0
   Graphic Set Font hFont1000
   Graphic Text Size "8" To x,y
   fSize = 1000/IIf( x/w > y/h , x/(w*factor) , y/(h*factor) )
   Font New "Tahoma", fSize, 1 To hFont
   Graphic Set Font hFont
   Function = fSize
End Function

Function SetSmallFont() As Long
   If Debug Then Txt.Print FuncName$
   Local x,y,w,h,fSize As Long, Factor As Single
   Factor = 0.7
   w = (D(1,1).x1 - D(1,1).x0)/3
   h = (D(1,1).y1 - D(1,1).y0)/3
   Graphic Set Font hFont1000
   Graphic Text Size "8" To x,y
   fSize = 1000/IIf( x/w > y/h , x/(w*factor) , y/(h*factor) )
   Font New "Tahoma", fSize, 0 To hFontS
   Font New "Tahoma", 1.2 * fSize, 1 To hFontSB
   Function = fSize
End Function

Sub RemoveUserEntries
   If Debug Then Txt.Print FuncName$
   Local x,y,j As Long
   For x = 1 To 9
      For y = 1 To 9
         If D(x,y).type = %User Then
            D(x,y).number           = 0
            D(x,y).bgcolor          = EmptyCellColor
            D(x,y).bignumbercolor   = OrigBigNumberColor
            For j = 1 To 9
               D(x,y).suggestcolor(j) = SuggestColor
               D(x,y).suggeststatus(j) = 0
               D(x,y).notecolor(j) = NoteGrayColor
               D(x,y).notestatus(j) = 0
            Next j
         End If
      Next y
   Next x
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   If Debug Then Txt.Print FuncName$
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub RebuildColors
   If Debug Then Txt.Print FuncName$
   Local x,y,z As Long
   For x = 1 To 9
      For y = 1 To 9
         If D(x,y).type = %Orig Then
            D(x,y).bgcolor           = OrigCellColor
            D(x,y).bignumbercolor    = OrigBigNumberColor
         Else
            D(x,y).bgcolor           = IIf(D(x,y).number, UserCellColor, EmptyCellColor)
            D(x,y).bignumbercolor    = UserBigNumberColor
         End If
         For z = 1 To 9
            D(x,y).suggestcolor(z) = SuggestColor
            D(x,y).notecolor(z)    = IIf(D(x,y).notestatus(z), NoteColor, NoteGrayColor)
         Next i
      Next y
   Next x
End Sub

Sub DisplayLocalHelp
   If Debug Then Txt.Print FuncName$
   Local temp$
   temp$ = "gbSudoku  " + $ver + $CrLf
   temp$ = temp$ + $CrLf + "Place a number 1-9 in each cell"
   temp$ = temp$ + $CrLf
   temp$ = temp$ + $CrLf + "Toolbar or keyboard can be used to enter a number"
   temp$ = temp$ + $CrLf + "Toolbar, keyboard or mouse can be used to move to a new cell"
   temp$ = temp$ + $CrLf + "Zero erases the number in a cell"
   temp$ = temp$ + $CrLf
   temp$ = temp$ + $CrLf + "Row cannot have the same number twice"
   temp$ = temp$ + $CrLf + "Column cannot have the same number twice"
   temp$ = temp$ + $CrLf + "Box cannot have the same number twice"
   temp$ = temp$ + $CrLf
   temp$ = temp$ + $CrLf + "Reset" + $Tab + "removes all user-entered numbers"
   temp$ = temp$ + $CrLf + "Clear" + $Tab + "removes all numbers (allows users to make custom game)"
   temp$ = temp$ + $CrLf + "Reveal" + $Tab + "inserts solution for selected cell"
   temp$ = temp$ + $CrLf + "Suggest" + $Tab + "displays valid moves for empty cells"
   temp$ = temp$ + $CrLf
   temp$ = temp$ + $CrLf + "Enjoy!"
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   MessageBox(0, (temp$), "Local Help", %MB_Ok + %MB_IconInformation)
   UnhookWindowsHookEx ghHook
End Sub

Sub SetUndoData(ByVal x As Long, ByVal y As Long)
   If Debug Then Txt.Print FuncName$

   If SX = UndoData(UndoPos).x And SY = UndoData(UndoPos).y And D(SX,SY).number = UndoData(UndoPos).n Then Exit Sub

   If MaxUndoPos = UBound(UndoData) Then
      Array Delete UndoData(0)
   Else
      Incr MaxUndoPos
   End If
   UndoPos = MaxUndoPos

   UndoData(UndoPos).x = x
   UndoData(UndoPos).y = y
   UndoData(UndoPos).n = D(x,y).number
End Sub

Sub Redo
   If Debug Then Txt.Print FuncName$
   If UndoPos >= MaxUndoPos Then
      If AllowSpeech Then
         ReadText "You have reached the end of the redo values!"
      Else
         Beep
      End If
      Exit Sub
   End If

   'current position
   'no action

   'new position takes on values from UndoData
   Incr UndoPos
   SX = UndoData(UndoPos).x
   SY = UndoData(UndoPos).y
   If UndoData(UndoPos).n Then
      If RuleCheck(UndoData(UndoPos).n,0) Then GetCellCandidates : DrawPuzzle
   Else
      D(SX,SY).number  = 0
      D(SX,SY).bgColor = EmptyCellColor
      GetCellCandidates : DrawPuzzle
   End If


End Sub

Sub Undo
   If Debug Then Txt.Print FuncName$


   If UndoPos = 0 Then
      If AllowSpeech Then
         ReadText "You have reached the start of the undo values!"
      Else
         Beep
      End If
      Exit Sub
   End If

   If SX <> UndoData(UndoPos).x Or SY <> UndoData(UndoPos).y Then
      'return to most recent entry on Undo statck
      SX = UndoData(UndoPos).x
      SY = UndoData(UndoPos).y
      If RuleCheck(UndoData(UndoPos).n,0) Then GetCellCandidates : DrawPuzzle
      Exit Sub
   End If

   If UndoPos = 1  Then
      If AllowSpeech Then
         ReadText "You have reached the start of the undo values!"
      Else
         Beep
      End If
      Exit Sub
   End If

   'current position becomes empty
   D(SX,SY).number  = 0
   D(SX,SY).bgColor = EmptyCellColor

   'new position takes on values from UndoData
   Decr UndoPos
   SX = UndoData(UndoPos).x
   SY = UndoData(UndoPos).y
   If RuleCheck(UndoData(UndoPos).n,0) Then GetCellCandidates : DrawPuzzle
End Sub

Sub RemoveConflictingCandidates(n As Long)
   Local x,y As Long
   'remove n from row containing SX
   For x = 1 To 9
      If x = SX Then Iterate For
      If D(x,SY).number = n Then
         SetUndoData(x,SY)
         D(x,SY).number = 0
         D(x,SY).bgColor = EmptyCellColor
      End If
   Next x
   'remove n from col containing SY
   For y = 1 To 9
      If y = SY Then Iterate For
      If D(SX,y).number = n Then
         SetUndoData(SX,y)
         D(SX,y).number = 0
         D(SX,y).bgcolor = EmptyCellColor
      End If
   Next y
   'remove n from box containing SX,SY
   For x = 1 To 9
      For y = 1 To 9
         If (x = SX) And (y = SY) Then Iterate For
         If D(x,y).box = D(SX,SY).box Then
            If D(x,y).number = n Then
               SetUndoData(x,y)
               D(x,y).number  = 0
               D(x,y).bgcolor = EmptyCellColor
            End If
         End If
      Next y
   Next x
End Sub

Sub ResetUndoData
   ReDim UndoData(50)
   UndoPos    = 0
   MaxUndoPos = 0
End Sub

Sub CreateContextMenu
    Menu New PopUp To hContext
    Menu Add String, hContext, "Empty",  %IDM_Empty,  %MF_Enabled
    Menu Add String, hContext, "Notes",  %IDM_Notes,  %MF_Enabled
    Menu Add String, hContext, "Suggest",  %IDM_Suggest,  %MF_Enabled
    Menu Add String, hContext, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hContext, "Clear Number (Selected Cell)",  %IDM_0,  %MF_Enabled
    Menu Add String, hContext, "Clear Notes (Selected Cell)",  %IDM_ClearNotesCell,  %MF_Enabled
    Menu Add String, hContext, "Clear Notes (All Cells)",  %IDM_ClearNotesAll,  %MF_Enabled
    Menu Add String, hContext, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hContext, "Toggle Note 1 Status",  %IDM_Note1,  %MF_Enabled
    Menu Add String, hContext, "Toggle Note 2 Status",  %IDM_Note2,  %MF_Enabled
    Menu Add String, hContext, "Toggle Note 3 Status",  %IDM_Note3,  %MF_Enabled
    Menu Add String, hContext, "Toggle Note 4 Status",  %IDM_Note4,  %MF_Enabled
    Menu Add String, hContext, "Toggle Note 5 Status",  %IDM_Note5,  %MF_Enabled
    Menu Add String, hContext, "Toggle Note 6 Status",  %IDM_Note6,  %MF_Enabled
    Menu Add String, hContext, "Toggle Note 7 Status",  %IDM_Note7,  %MF_Enabled
    Menu Add String, hContext, "Toggle Note 8 Status",  %IDM_Note8,  %MF_Enabled
    Menu Add String, hContext, "Toggle Note 9 Status",  %IDM_Note9,  %MF_Enabled
    Menu Add String, hContext, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hContext, "Enter the Number 1",  %IDM_1,  %MF_Enabled
    Menu Add String, hContext, "Enter the Number 2",  %IDM_2,  %MF_Enabled
    Menu Add String, hContext, "Enter the Number 3",  %IDM_3,  %MF_Enabled
    Menu Add String, hContext, "Enter the Number 4",  %IDM_4,  %MF_Enabled
    Menu Add String, hContext, "Enter the Number 5",  %IDM_5,  %MF_Enabled
    Menu Add String, hContext, "Enter the Number 6",  %IDM_6,  %MF_Enabled
    Menu Add String, hContext, "Enter the Number 7",  %IDM_7,  %MF_Enabled
    Menu Add String, hContext, "Enter the Number 8",  %IDM_8,  %MF_Enabled
    Menu Add String, hContext, "Enter the Number 9",  %IDM_9,  %MF_Enabled
End Sub

Sub ClearNotes(Flag As Long) '0-cell 1=all
   Local x,y,k As Long
   If Flag Then
      'all
      For x = 1 To 9
         For y = 1 To 9
            For k = 1 To 9
               D(x,y).notestatus(k) = 0    'all off
               D(x,y).notecolor(k) = NoteGrayColor
            Next k
         Next n
      Next
   Else
      'cell only
      For k = 1 To 9
         D(SX,SY).notestatus(k) = 0    'all off
         D(SX,SY).notecolor(k) = NoteGrayColor
      Next k
   End If
End Sub

Sub SetAspectRatio(ar As Single)
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Dialog Set Client hDlg, w, AR*w + TBM
   Control Get Size hDlg, %IDC_Graphic To w,h
End Sub

Sub ToggleNote(n As Long)
   D(SX,SY).notestatus(n) = D(SX,SY).notestatus(n) Xor 1
   D(SX,SY).notecolor(n)  = IIf(D(SX,SY).notestatus(n), NoteColor, NoteGrayColor)
End Sub

Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_Graphic, w,h-TBM
   BuildCellCoordinates
   SetBigFont : SetSmallFont
   DrawPuzzle
End Sub
